package uci.inf221.lunarLander.arch;

public abstract class Port {
	public enum PortDirection {
		IN, OUT, INOUT;
	}

	protected Port connectedPort;
	private PortDirection direction = PortDirection.INOUT;

	public void connectTo(Port port) {
		this.connectedPort = port;
		port.connectedPort = this;
	}

	protected abstract void receiveMessage(Message message);

	protected void sendMessage(Message message) {
		if (connectedPort != null
				&& (direction == PortDirection.OUT || direction == PortDirection.INOUT)) {
			connectedPort.handleMessage(message);
		}
	}

	protected void handleMessage(Message message) {
		if (direction == PortDirection.IN || direction == PortDirection.INOUT) {
			receiveMessage(message);
		}
	}

	public void setDirection(PortDirection direction) {
		this.direction = direction;
	}
}
