package uci.inf221.lunarLander.arch.c2;

import uci.inf221.lunarLander.arch.Message;

public class C2Request extends Message {
	private static final long serialVersionUID = -150535884257889547L;

	private transient C2Component source;
	private transient Object sourceData;

	public C2Request(C2Component source) {
		this(source, null);
	}

	public C2Request(C2Component source, Object sourceData) {
		this.source = source;
		this.sourceData = sourceData;
	}

	public C2Component getSource() {
		return source;
	}

	public Object getSourceData() {
		return sourceData;
	}

	@Override
	public C2Request clone() {
		C2Request clone = (C2Request) super.clone();
		clone.source = this.source;
		clone.sourceData = this.sourceData;
		return clone;
	}
}
