package uci.inf221.lunarLander.arch.c2;

import uci.inf221.lunarLander.arch.Message;
import uci.inf221.lunarLander.arch.Port;

public abstract class C2TopPort extends Port {

	@Override
	protected void receiveMessage(Message message) {
		if (!(message instanceof C2Notification))
			throw new RuntimeException(
					"Top port received message that is not a notification: "
							+ message.toString());
		
		receiveNotification((C2Notification) message);
	}
	
	public void sendRequest(C2Request message) {
		sendMessage(message);
	}

	protected abstract void receiveNotification(C2Notification notification);

}
