package uci.inf221.lunarLander.dataStore.connector;

import uci.inf221.lunarLander.arch.Port.PortDirection;
import uci.inf221.lunarLander.arch.c2.C2Connector;

public class DataStoreConnector extends C2Connector {

	public static final String PORT_IDENTIFIER_CLOCK_COMPONENT = "clock";
	public static final String PORT_IDENTIFIER_STATUS_COMPONENT = "status";
	public static final String PORT_IDENTIFIER_LEVEL_COMPONENT = "level";
	public static final String PORT_IDENTIFIER_SHIPS_COMPONENT = "ships";
	public static final String PORT_IDENTIFIER_ASTEROIDS_COMPONENT = "asteroids";
	public static final String PORT_IDENTIFIER_BULLETS_COMPONENT = "bullets";
	public static final String PORT_IDENTIFIER_LOGIC_CONNECTOR = "logic";
	public static final String PORT_IDENTIFIER_COLLISION_DETECTION_LOGIC_COMPONENT = "collision_detection_logic";
	public static final String PORT_IDENTIFIER_POSITION_LOGIC_COMPONENT = "position_logic";
	public static final String PORT_IDENTIFIER_GUI_COMPONENT = "gui";
	public static final String PORT_IDENTIFIER_CLIENT_TO_SERVER_CONNECTOR = "client_to_server";
	public static final String PORT_IDENTIFIER_THRESHOLDING_LOGIC_COMPONENT = "thresholding_logic";
	public static final String PORT_IDENTIFIER_ASTEROID_MANAGER_COMPONENT = "asteroid_manager";
	public static final String PORT_IDENTIFIER_LEVEL_MANAGER_COMPONENT = "level_manager";
	public static final String PORT_IDENTIFIER_SERVER_TO_CLIENTS_CONNECTOR = "server_to_clients";

	@Override
	protected void createPorts() {
		addTopPort(PORT_IDENTIFIER_CLOCK_COMPONENT);
		addTopPort(PORT_IDENTIFIER_STATUS_COMPONENT);
		addTopPort(PORT_IDENTIFIER_LEVEL_COMPONENT);
		addTopPort(PORT_IDENTIFIER_SHIPS_COMPONENT);
		addTopPort(PORT_IDENTIFIER_ASTEROIDS_COMPONENT);
		addTopPort(PORT_IDENTIFIER_BULLETS_COMPONENT);

		addBottomPort(PORT_IDENTIFIER_LOGIC_CONNECTOR);
		addBottomPort(PORT_IDENTIFIER_COLLISION_DETECTION_LOGIC_COMPONENT);
		addBottomPort(PORT_IDENTIFIER_POSITION_LOGIC_COMPONENT);
		addBottomPort(PORT_IDENTIFIER_GUI_COMPONENT);
		addBottomPort(PORT_IDENTIFIER_CLIENT_TO_SERVER_CONNECTOR).setDirection(
				PortDirection.IN);
		addBottomPort(PORT_IDENTIFIER_THRESHOLDING_LOGIC_COMPONENT)
				.setDirection(PortDirection.OUT);
		addBottomPort(PORT_IDENTIFIER_ASTEROID_MANAGER_COMPONENT);
		addBottomPort(PORT_IDENTIFIER_LEVEL_MANAGER_COMPONENT);
		addBottomPort(PORT_IDENTIFIER_SERVER_TO_CLIENTS_CONNECTOR);
	}

}
