package uci.inf221.lunarLander.dataStore.message;

import java.util.UUID;

import uci.inf221.lunarLander.arch.c2.C2Component;
import uci.inf221.lunarLander.arch.c2.C2Request;

public class UpdateMovementVectorAccelerationRequest extends C2Request {

	private static final long serialVersionUID = 8686465960156357113L;

	private UUID entityId;
	private float[] acceleration;

	public UpdateMovementVectorAccelerationRequest(C2Component source,
			UUID entityId, float[] acceleration) {
		super(source);
		this.entityId = entityId;
		this.acceleration = acceleration;
	}

	public UUID getEntityId() {
		return entityId;
	}

	public float[] getAcceleration() {
		return acceleration;
	}

}
