package uci.inf221.lunarLander.dataStore.message;

import java.util.UUID;

import uci.inf221.lunarLander.arch.c2.C2Component;
import uci.inf221.lunarLander.arch.c2.C2Request;

public class UpdateMovementVectorPositionAndSpeedRequest extends C2Request {

	private static final long serialVersionUID = -6530220953402175646L;

	private UUID entityId;
	private float[] position;
	private float[] speed;
	private long clockTick;

	public UpdateMovementVectorPositionAndSpeedRequest(C2Component source,
			UUID entityId, float[] position, float[] speed, long clockTick) {
		super(source);
		this.entityId = entityId;
		this.position = position;
		this.speed = speed;
		this.clockTick = clockTick;
	}

	public UUID getEntityId() {
		return entityId;
	}

	public float[] getPosition() {
		return position;
	}

	public float[] getSpeed() {
		return speed;
	}

	public long getClockTick() {
		return clockTick;
	}

}
