package uci.inf221.lunarLander.dataStore.message;

import java.util.UUID;

import uci.inf221.lunarLander.arch.c2.C2Component;
import uci.inf221.lunarLander.arch.c2.C2Request;
import uci.inf221.lunarLander.dataStore.entities.MovementVector;

public class UpdateMovementVectorRequest extends C2Request {

	private static final long serialVersionUID = 246471306747831747L;

	private UUID entityId;
	private MovementVector movementVector;

	public UpdateMovementVectorRequest(C2Component source, UUID entityId,
			MovementVector movementVector) {
		this(source, null, entityId, movementVector);
	}

	public UpdateMovementVectorRequest(C2Component source, Object sourceData,
			UUID entityId, MovementVector movementVector) {
		super(source, sourceData);
		this.entityId = entityId;
		this.movementVector = movementVector;
	}

	public UUID getEntityId() {
		return entityId;
	}

	public MovementVector getMovementVector() {
		return movementVector;
	}

}
