package uci.inf221.lunarLander.net.connector.clientToServer.component;

import uci.inf221.lunarLander.arch.Port.PortDirection;
import uci.inf221.lunarLander.arch.c2.C2Component;
import uci.inf221.lunarLander.arch.c2.C2Notification;
import uci.inf221.lunarLander.arch.c2.C2Request;
import uci.inf221.lunarLander.dataStore.message.MovementVectorUpdatedNotification;
import uci.inf221.lunarLander.net.connector.clientToServer.message.NewMessageNotification;

public class ClientMessageComposerComponent extends C2Component {

	public static final String PORT_IDENTIFIER_THRESHOLDING_PORT_CONNECTOR = "thresholding_port";
	public static final String PORT_IDENTIFIER_CONNECTION_MANAGER_CONNECTOR = "connection_manager";

	@Override
	protected void createPorts() {
		addTopPort(PORT_IDENTIFIER_THRESHOLDING_PORT_CONNECTOR).setDirection(
				PortDirection.IN);
		addBottomPort(PORT_IDENTIFIER_CONNECTION_MANAGER_CONNECTOR)
				.setDirection(PortDirection.OUT);
	}

	@Override
	protected void initialize() {
	}

	@Override
	public void start() {
	}

	@Override
	public void stop() {
	}

	@Override
	public void waitForStop() {
	}

	@Override
	protected void receiveNotification(C2Notification notification) {
		boolean important = !(notification instanceof MovementVectorUpdatedNotification);
		sendNotification(new NewMessageNotification(this, notification,
				important));
	}

	@Override
	protected void receiveRequest(C2Request request) {
	}

}
