package uci.inf221.lunarLander.net.connector.clientToServer.component;

import uci.inf221.lunarLander.arch.Port.PortDirection;
import uci.inf221.lunarLander.arch.c2.C2Component;
import uci.inf221.lunarLander.arch.c2.C2Notification;
import uci.inf221.lunarLander.arch.c2.C2Request;
import uci.inf221.lunarLander.dataStore.entities.Level.LevelStatus;
import uci.inf221.lunarLander.dataStore.message.ChangeNTPServerRequest;
import uci.inf221.lunarLander.dataStore.message.UpdateLevelStatusRequest;
import uci.inf221.lunarLander.net.connector.clientToServer.message.HandleConnectionStateChangeRequest;
import uci.inf221.lunarLander.net.connector.serverToClients.entity.RemoteConnectionId;
import uci.inf221.lunarLander.server.Server;

public class ServerConnectionStateChangeHandlerComponent extends C2Component {

	public static final String PORT_IDENTIFIER_DATA_STORE_PORT_CONNECTOR = "data_store_port";
	public static final String PORT_IDENTIFIER_CONNECTION_MANAGER_CONNECTOR = "connection_manager";

	@Override
	protected void createPorts() {
		addTopPort(PORT_IDENTIFIER_DATA_STORE_PORT_CONNECTOR).setDirection(
				PortDirection.OUT);
		addBottomPort(PORT_IDENTIFIER_CONNECTION_MANAGER_CONNECTOR)
				.setDirection(PortDirection.IN);
	}

	@Override
	protected void initialize() {
	}

	@Override
	public void start() {
	}

	@Override
	public void stop() {
	}

	@Override
	public void waitForStop() {
	}

	@Override
	protected void receiveNotification(C2Notification notification) {
	}

	@Override
	protected void receiveRequest(C2Request request) {
		if (request instanceof HandleConnectionStateChangeRequest) {
			if (((HandleConnectionStateChangeRequest) request).isConnected()) {
				sendRequest(new ChangeNTPServerRequest(this,
						((HandleConnectionStateChangeRequest) request)
								.getRemoteAddress().getHostAddress(),
						Server.NTP_PORT));
			} else {
				sendRequest(new UpdateLevelStatusRequest(this,
						new RemoteConnectionId(-1), LevelStatus.ERROR));
			}
		}
	}

}
