package uci.inf221.lunarLander.net.connector.serverToClients.message;

import java.io.Serializable;

import uci.inf221.lunarLander.arch.Message;
import uci.inf221.lunarLander.arch.c2.C2Component;
import uci.inf221.lunarLander.arch.c2.C2Notification;

public class NewMessageNotification extends C2Notification {

	public enum TargetMode implements Serializable {
		ALL, SINGLE, EXCLUDING
	}

	private static final long serialVersionUID = -5177459782750451484L;

	private transient Message message;
	private boolean important;
	private Integer targetConnectionId;
	private TargetMode targetMode;

	public NewMessageNotification(C2Component source, Message message,
			boolean important) {
		this(source, message, important, null, TargetMode.ALL);
	}

	public NewMessageNotification(C2Component source, Message message,
			boolean important, Integer targetConnectionId, TargetMode targetMode) {
		super(source);
		this.message = message;
		this.important = important;
		this.targetConnectionId = targetConnectionId;
		this.targetMode = targetMode;
	}

	public Message getMessage() {
		return message;
	}

	public boolean isImportant() {
		return important;
	}

	public Integer getTargetConnectionId() {
		return targetConnectionId;
	}

	public TargetMode getTargetMode() {
		return targetMode;
	}

	@Override
	public NewMessageNotification clone() {
		NewMessageNotification clone = (NewMessageNotification) super.clone();
		clone.message = this.message.clone();
		return clone;
	}

}
